(define-structure foo (export make-car-hash-table baz
                              (quux :syntax)
                              )
  (open scheme tables)
  (for-syntax (open scheme tables))
  (begin
    (display "Hello, world!")
    (newline)
    (define (make-car-hash-table) (make-table car))
    (define baz (make-car-hash-table))
    (define p (cons 0 'foo))
    (table-set! baz p 5)
    (display (table-ref baz p))
    (newline)
    (define-syntax quux
      (lambda (form rename compare)
        (let ((table (make-symbol-table)))
          (table-set! table 'foo
                      `(,(rename 'TABLE-REF)
                        ,(rename 'BAZ)
                        ,(rename 'P)))
          (or (table-ref table (cadr form))
              `(,(rename 'QUOTE) ,(cadr form)))))
      (TABLE-REF BAZ P QUOTE))
    ))
